diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 1f744bec9..b1373963b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -2185,168 +1989,156 @@ public class World implements MutableWorldSource {
         this.scheduleLightingUpdate(lightLayer, new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ));
     }
 
-    public void updateSkyBrightness()
-    {
-        int i = worldType.getSkyDarken(this, getWorldTime(), 1.0F);
-        if(i != skyDarken)
-        {
-            skyDarken = i;
+    public void updateSkyBrightness() {
+        int i = this.worldType.getSkyDarken(this, getWorldTime(), 1.0F);
+        if (i != this.skyDarken) {
+            this.skyDarken = i;
         }
     }
 
     public void allChanged(boolean lightChanged, boolean seasonChanged) {
-		for(int i= 0; i < listeners.size(); i++) {
-            listeners.get(i).allChanged(lightChanged, seasonChanged);
-		}
+        for (int i = 0; i < this.listeners.size(); i++) {
+            this.listeners.get(i).allChanged(lightChanged, seasonChanged);
+        }
     }
 
-    protected void updateSleepingPlayers()
-    {
-        if(areEnoughPlayersFullyAsleep())
-        {
+    protected void updateSleepingPlayers() {
+        if (areEnoughPlayersFullyAsleep()) {
             boolean wasInterrupted = false;
-            if(getSpawnerConfig().canHostileSpawn(this) && getPlayersRequiredToSkipNight() <= 1)
-            {
-                wasInterrupted = SpawnerMobs.performSleepSpawning(this, players);
-            }
-            if(!wasInterrupted)
-            {
-                long timePlusOneDay = levelData.getWorldTime() + Global.DAY_LENGTH_TICKS;
-                levelData.setWorldTime(timePlusOneDay - timePlusOneDay % Global.DAY_LENGTH_TICKS + worldType.getSunriseTick(this) + DAY_LENGTH_TICKS / 24);
-                
+            if (getSpawnerConfig().canHostileSpawn(this) && getPlayersRequiredToSkipNight() <= 1) {
+                wasInterrupted = SpawnerMobs.performSleepSpawning(this, this.players);
+            }
+            if (!wasInterrupted) {
+                long timePlusOneDay = this.levelData.getWorldTime() + Global.DAY_LENGTH_TICKS;
+                this.levelData.setWorldTime(timePlusOneDay - timePlusOneDay % Global.DAY_LENGTH_TICKS + this.worldType.getSunriseTick(this) + DAY_LENGTH_TICKS / 24);
+
                 wakeUpAllPlayers();
             }
         }
     }
 
-	public void tick() {
+    public void tick() {
         Debug.push("misc");
-        immediatelyUpdatedPositions.clear();
+        this.immediatelyUpdatedPositions.clear();
         Debug.change("weather");
-        weatherManager.tick();
+        this.weatherManager.tick();
         Debug.change("misc");
         updateSleepingPlayers();
         Debug.change("spawning");
         // TODO mob spawning seems to be the cause of many lag spikes, specifically the checks for is a mob is allowed to spawn at a certain xyz position seem to be the worst offenders
         SpawnerMobs.performSpawning(this, getSpawnerConfig());
         Debug.change("chunk");
-        chunkProvider.tick();
+        this.chunkProvider.tick();
 
         Debug.change("autosave");
         int autosaveTimeInSeconds = Global.accessor.getAutosaveTimer();
         int autosaveTimeInTicks = (autosaveTimeInSeconds * 20);
 
         AUTOSAVE = autosaveTimeInTicks != 0;
-        if(AUTOSAVE && runtime % (long) autosaveTimeInTicks == 0L) {
+        if (AUTOSAVE && this.runtime % (long) autosaveTimeInTicks == 0L) {
             saveWorld(false, null, true);
         }
 
         Debug.change("misc");
-        if(getGameRuleValue(GameRules.DO_DAY_CYCLE)) {
-            levelData.setWorldTime(levelData.getWorldTime() + 1L);
+        if (getGameRuleValue(GameRules.DO_DAY_CYCLE)) {
+            this.levelData.setWorldTime(this.levelData.getWorldTime() + 1L);
         }
 
-        runtime++;
+        this.runtime++;
 
         tickPendingTicks(false);
         Debug.change("blocks&cavesSounds");
         updateBlocksAndPlayCaveSounds();
         Debug.change("season&light");
         updateSeasonAndLight();
-        if(rainbowTicks > 0)
-        {
-            rainbowTicks--;
+        if (this.rainbowTicks > 0) {
+            this.rainbowTicks--;
         }
         Debug.pop();
-	}
+    }
 
-	public void updateSeasonAndLight() {
-		boolean seasonChanged = false;
-		boolean lightChanged = false;
+    public void updateSeasonAndLight() {
+        boolean seasonChanged = false;
+        boolean lightChanged = false;
 
-		int currentDayCount = ((int) (levelData.getWorldTime() / Global.DAY_LENGTH_TICKS));
-		if(currentDayCount != dayCountLastTick) {
-			dayCountLastTick = currentDayCount;
-            if (!isClientSide){
-                dayCanHaveRainbow = rand.nextInt(3) == 0;
+        int currentDayCount = ((int) (this.levelData.getWorldTime() / Global.DAY_LENGTH_TICKS));
+        if (currentDayCount != this.dayCountLastTick) {
+            this.dayCountLastTick = currentDayCount;
+            if (!this.isClientSide) {
+                this.dayCanHaveRainbow = this.rand.nextInt(3) == 0;
             } else {
-                dayCanHaveRainbow = true;
-            }
-			seasonChanged = true;
-		}
-
-		int currentSkyDarken = worldType.getSkyDarken(this, getWorldTime(), 1.0f);
-		if(currentSkyDarken != skyDarken) {
-			skyDarken = currentSkyDarken;
-			lightChanged = true;
-		}
-
-		if(seasonChanged || lightChanged) {
-			allChanged(lightChanged, seasonChanged);
-		}
-	}
-
-    protected void updateBlocksAndPlayCaveSounds()
-    {
-        positionsToUpdate.clear();
-        for(int i = 0; i < players.size(); i++)
-        {
-            Player entityplayer = players.get(i);
+                this.dayCanHaveRainbow = true;
+            }
+            seasonChanged = true;
+        }
+
+        int currentSkyDarken = this.worldType.getSkyDarken(this, getWorldTime(), 1.0f);
+        if (currentSkyDarken != this.skyDarken) {
+            this.skyDarken = currentSkyDarken;
+            lightChanged = true;
+        }
+
+        if (seasonChanged || lightChanged) {
+            allChanged(lightChanged, seasonChanged);
+        }
+    }
+
+    protected void updateBlocksAndPlayCaveSounds() {
+        this.positionsToUpdate.clear();
+        for (int i = 0; i < this.players.size(); i++) {
+            Player entityplayer = this.players.get(i);
             int playerChunkX = MathHelper.floor(entityplayer.x / Chunk.CHUNK_SIZE_X);
             int playerChunkZ = MathHelper.floor(entityplayer.z / Chunk.CHUNK_SIZE_Z);
             byte radius = 9;
-            for(int x = -radius; x <= radius; x++)
-            {
-                for(int z = -radius; z <= radius; z++)
-                {
-                    positionsToUpdate.add(new ChunkCoordinate(x + playerChunkX, z + playerChunkZ));
+            for (int x = -radius; x <= radius; x++) {
+                for (int z = -radius; z <= radius; z++) {
+                    this.positionsToUpdate.add(new ChunkCoordinate(x + playerChunkX, z + playerChunkZ));
                 }
             }
         }
 
-        if(caveSoundCounter > 0)
-        {
-            caveSoundCounter--;
+        if (this.caveSoundCounter > 0) {
+            this.caveSoundCounter--;
         }
         final int randomTicks = getGameRuleValue(GameRules.RANDOM_TICK_SPEED);
-        for (ChunkCoordinate coordinate : positionsToUpdate) {
+        for (ChunkCoordinate coordinate : this.positionsToUpdate) {
             int chunkBlockX = coordinate.x * Chunk.CHUNK_SIZE_X;
             int chunkBlockZ = coordinate.z * Chunk.CHUNK_SIZE_Z;
             if (!isChunkLoaded(coordinate.x, coordinate.z)) {
                 continue;
             }
             Chunk chunk = getChunkFromChunkCoords(coordinate.x, coordinate.z);
-            updateLCG = updateLCG * 3 + 0x3c6ef35f;
-            int randVal = updateLCG >> 2;
+            this.updateLCG = this.updateLCG * 3 + 0x3c6ef35f;
+            int randVal = this.updateLCG >> 2;
             int blockX = randVal & (Chunk.CHUNK_SIZE_X - 1);
             int blockZ = (randVal / (Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (Chunk.CHUNK_SIZE_Z - 1);
 
-            if (caveSoundCounter == 0) {
+            if (this.caveSoundCounter == 0) {
                 int blockY = (randVal / (HEIGHT_BLOCKS * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (HEIGHT_BLOCKS - 1);
                 int id = chunk.getBlockID(blockX, blockY, blockZ);
                 blockX += chunkBlockX;
                 blockZ += chunkBlockZ;
-                if (id == 0 && getFullBlockLightValue(blockX, blockY, blockZ) <= rand.nextInt(8) && getSavedLightValue(LightLayer.Sky, blockX, blockY, blockZ) <= 0) {
+                if (id == 0 && getFullBlockLightValue(blockX, blockY, blockZ) <= this.rand.nextInt(8) && getSavedLightValue(LightLayer.Sky, blockX, blockY, blockZ) <= 0) {
                     Player closestPlayer = getClosestPlayer((double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, 8D);
                     if (closestPlayer != null && closestPlayer.distanceToSqr((double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D) > 4D) {
-                        playSoundEffect(null, SoundCategory.CAVE_SOUNDS, (double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, "ambient.cave.cave", 0.7F, 0.8F + rand.nextFloat() * 0.2F);
-                        caveSoundCounter = rand.nextInt(12000) + 6000;
+                        playSoundEffect(null, SoundCategory.CAVE_SOUNDS, (double) blockX + 0.5D, (double) blockY + 0.5D, (double) blockZ + 0.5D, "ambient.cave.cave", 0.7F, 0.8F + this.rand.nextFloat() * 0.2F);
+                        this.caveSoundCounter = this.rand.nextInt(12000) + 6000;
                     }
                 }
             }
 
             if (getCurrentWeather() != null) {
-                updateLCG = updateLCG * 3 + 0x3c6ef35f;
-                randVal = updateLCG >> 2;
+                this.updateLCG = this.updateLCG * 3 + 0x3c6ef35f;
+                randVal = this.updateLCG >> 2;
                 int weatherBlockX = randVal & (Chunk.CHUNK_SIZE_X - 1);
                 int weatherBlockZ = (randVal / (Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (Chunk.CHUNK_SIZE_Z - 1);
-                getCurrentWeather().doEnvironmentUpdate(this, rand, chunkBlockX + weatherBlockX, chunkBlockZ + weatherBlockZ);
+                getCurrentWeather().doEnvironmentUpdate(this, this.rand, chunkBlockX + weatherBlockX, chunkBlockZ + weatherBlockZ);
             }
 
             for (int s = 0; s < Chunk.CHUNK_SECTIONS; s++) {
                 for (int i = 0; i < randomTicks; i++) {
-                    updateLCG = updateLCG * 3 + 0x3c6ef35f;
-                    int iRandVal = updateLCG >> 2;
+                    this.updateLCG = this.updateLCG * 3 + 0x3c6ef35f;
+                    int iRandVal = this.updateLCG >> 2;
                     int iBlockX = iRandVal & (Chunk.CHUNK_SIZE_X - 1);
                     int iBlockZ = (iRandVal / (Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (Chunk.CHUNK_SIZE_Z - 1);
                     int iBlockY = (iRandVal / (ChunkSection.SECTION_SIZE_Y * Chunk.CHUNK_SIZE_Z * Chunk.CHUNK_SIZE_X)) & (ChunkSection.SECTION_SIZE_Y - 1) + s * ChunkSection.SECTION_SIZE_Y;
@@ -2362,57 +2154,48 @@ public class World implements MutableWorldSource {
 
     public boolean tickPendingTicks(final boolean all) {
         int count = this.tickNextTickList.size();
-        if(count > MAX_SCHEDULED_TICKS_IN_TICK)
-        {
+        if (count != this.tickNextTickSet.size()) {
+            throw new IllegalStateException("TickNextTick lists out of sync");
+        }
+        if (count > MAX_SCHEDULED_TICKS_IN_TICK) {
             count = MAX_SCHEDULED_TICKS_IN_TICK;
         }
 
-        for (int i = 0; i < count; i++)
-        {
+        for (int i = 0; i < count; i++) {
             final @NotNull NextTickListEntry entry = this.tickNextTickList.first();
-            if(!all && entry.getEndTime() > this.getWorldTime())
-            {
+            if (!all && entry.delay > runtime) {
                 break;
             }
-            if (!entry.loaded) {
-                this.tickNextTickList.remove(entry);
-            }
+            this.tickNextTickList.remove(entry);
+            this.tickNextTickSet.remove(entry);
             final byte radius = 8;
-            if(!this.areBlocksLoaded(entry.x - radius, entry.y - radius, entry.z - radius, entry.x + radius, entry.y + radius, entry.z + radius)) {
-                if (entry.loaded) { // Re-insert loaded tick with appropriate delay
-                    entry.creationTime = this.getWorldTime();
-                }
+            if (!this.areBlocksLoaded(entry.tilePos.x - radius, entry.tilePos.y - radius, entry.tilePos.z - radius, entry.tilePos.x + radius, entry.tilePos.y + radius, entry.tilePos.z + radius)) {
                 continue;
             }
-            if (entry.loaded) {
-                this.tickNextTickList.remove(entry);
-            }
-            final @NotNull Chunk chunk = Objects.requireNonNull(this.getChunkFromBlockCoords(entry.x, entry.z));
-            chunk.dropTick(entry);
-            final @Nullable Block<?> block = this.getBlock(entry.x, entry.y, entry.z);
-            if(block != null && block.id() == entry.blockId)
-            {
-                block.updateTick(this, entry.x, entry.y, entry.z, this.rand, false);
+            final @Nullable Block<?> block = this.getBlock(entry.tilePos);
+            if (block != null && block.id() == entry.blockId) {
+                block.updateTick(this, entry.tilePos, this.rand, false);
             }
         }
 
-        return !tickNextTickList.isEmpty();
+        return !this.tickNextTickList.isEmpty();
     }
 
     public void randomDisplayUpdates(final @NotNull TilePos tilePos) {
         final int radius = 16;
         final @NotNull Random random = new Random();
 
-        for(int i = 0; i < ANIMATION_TICKS_PER_TICK; i++) {
-            final @NotNull TilePos randomPos = tilePos.add(
+        TilePos randomPos = new TilePos();
+        for (int i = 0; i < ANIMATION_TICKS_PER_TICK; i++) {
+            tilePos.add(
                 this.rand.nextInt(radius) - this.rand.nextInt(radius),
                 this.rand.nextInt(radius) - this.rand.nextInt(radius),
-                this.rand.nextInt(radius) - this.rand.nextInt(radius)
-            );
+                this.rand.nextInt(radius) - this.rand.nextInt(radius),
+                randomPos);
 
             final @Nullable Block<?> block = this.getBlock(randomPos);
             if (block != null) {
-                block.animationTick(this, randomPos.x, randomPos.y, randomPos.z, random);
+                block.animationTick(this, randomPos, random);
             }
         }
     }
@@ -2422,40 +2205,32 @@ public class World implements MutableWorldSource {
         this.randomDisplayUpdates(new TilePos(x, y, z));
     }
 
-    public List<Entity> getEntitiesWithinAABBExcludingEntity(Entity entity, AABB aabb)
-    {
-        entityBuffer.clear();
-        int minX = MathHelper.floor((aabb.minX - 2D) / Chunk.CHUNK_SIZE_X);
-        int maxX = MathHelper.floor((aabb.maxX + 2D) / Chunk.CHUNK_SIZE_X);
-        int minZ = MathHelper.floor((aabb.minZ - 2D) / Chunk.CHUNK_SIZE_Z);
-        int maxZ = MathHelper.floor((aabb.maxZ + 2D) / Chunk.CHUNK_SIZE_Z);
-        for(int x = minX; x <= maxX; x++)
-        {
-            for(int z = minZ; z <= maxZ; z++)
-            {
-                if(isChunkLoaded(x, z))
-                {
-                    getChunkFromChunkCoords(x, z).getEntitiesWithin(entity, aabb, entityBuffer);
+    public @NotNull List<@NotNull Entity> getEntitiesWithinAABBExcludingEntity(@Nullable Entity entity, @NotNull AABBdc aabb) {
+        this.entityBuffer.clear();
+        int minX = MathHelper.floor((aabb.minX() - 2D) / Chunk.CHUNK_SIZE_X);
+        int maxX = MathHelper.floor((aabb.maxX() + 2D) / Chunk.CHUNK_SIZE_X);
+        int minZ = MathHelper.floor((aabb.minZ() - 2D) / Chunk.CHUNK_SIZE_Z);
+        int maxZ = MathHelper.floor((aabb.maxZ() + 2D) / Chunk.CHUNK_SIZE_Z);
+        for (int x = minX; x <= maxX; x++) {
+            for (int z = minZ; z <= maxZ; z++) {
+                if (isChunkLoaded(x, z)) {
+                    getChunkFromChunkCoords(x, z).getEntitiesWithin(entity, aabb, this.entityBuffer);
                 }
             }
         }
 
-        return entityBuffer;
+        return this.entityBuffer;
     }
 
-    public <T extends Entity> @NotNull List<@NotNull T> getEntitiesWithinAABB(Class<T> ofClass, AABB aabb)
-    {
-        int minX = MathHelper.floor((aabb.minX - 2D) / Chunk.CHUNK_SIZE_X);
-        int maxX = MathHelper.floor((aabb.maxX + 2D) / Chunk.CHUNK_SIZE_X);
-        int minZ = MathHelper.floor((aabb.minZ - 2D) / Chunk.CHUNK_SIZE_Z);
-        int maxZ = MathHelper.floor((aabb.maxZ + 2D) / Chunk.CHUNK_SIZE_Z);
+    public <T extends Entity> @NotNull List<@NotNull T> getEntitiesWithinAABB(@NotNull Class<T> ofClass, @NotNull AABBdc aabb) {
+        int minX = MathHelper.floor((aabb.minX() - 2D) / Chunk.CHUNK_SIZE_X);
+        int maxX = MathHelper.floor((aabb.maxX() + 2D) / Chunk.CHUNK_SIZE_X);
+        int minZ = MathHelper.floor((aabb.minZ() - 2D) / Chunk.CHUNK_SIZE_Z);
+        int maxZ = MathHelper.floor((aabb.maxZ() + 2D) / Chunk.CHUNK_SIZE_Z);
         List<@NotNull T> entities = new ArrayList<>();
-        for(int x = minX; x <= maxX; x++)
-        {
-            for(int z = minZ; z <= maxZ; z++)
-            {
-                if(isChunkLoaded(x, z))
-                {
+        for (int x = minX; x <= maxX; x++) {
+            for (int z = minZ; z <= maxZ; z++) {
+                if (isChunkLoaded(x, z)) {
                     getChunkFromChunkCoords(x, z).getEntitiesWithin(ofClass, aabb, entities);
                 }
             }
@@ -2465,14 +2240,12 @@ public class World implements MutableWorldSource {
         return entities;
     }
 
-    public List<Entity> getLoadedEntityList()
-    {
-        return entities;
+    public @NotNull List<@NotNull Entity> getLoadedEntityList() {
+        return this.entities;
     }
 
-    public List<TileEntity> getLoadedTileEntityList()
-    {
-        return tileEntityList;
+    public @NotNull List<@NotNull TileEntity> getLoadedTileEntityList() {
+        return this.tileEntityList;
     }
 
     public void updateTileEntityChunkAndSendToPlayer(final @NotNull TilePos tilePos, final @NotNull TileEntity tileEntity) {
@@ -2490,11 +2263,10 @@ public class World implements MutableWorldSource {
         this.updateTileEntityChunkAndSendToPlayer(new TilePos(x, y, z), tileEntity);
     }
 
-    public int countEntities(Class<?> clazz)
-    {
+    public int countEntities(Class<?> clazz) {
         int i = 0;
-        for (int j = 0, entitiesSize = entities.size(); j < entitiesSize; j++) {
-            Entity entity = entities.get(j);
+        for (int j = 0, entitiesSize = this.entities.size(); j < entitiesSize; j++) {
+            Entity entity = this.entities.get(j);
             if (clazz.isAssignableFrom(entity.getClass())) {
                 i++;
             }
@@ -2503,9 +2275,8 @@ public class World implements MutableWorldSource {
         return i;
     }
 
-    public void addLoadedEntities(List<Entity> list)
-    {
-        entities.addAll(list);
+    public void addLoadedEntities(List<Entity> list) {
+        this.entities.addAll(list);
         for (int i = 0, listSize = list.size(); i < listSize; i++) {
             Entity entity = list.get(i);
             obtainEntitySkin(entity);
@@ -2513,19 +2284,17 @@ public class World implements MutableWorldSource {
 
     }
 
-    public void unloadEntities(List<Entity> list)
-    {
-        entitiesToRemove.addAll(list);
+    public void unloadEntities(List<Entity> list) {
+        this.entitiesToRemove.addAll(list);
     }
 
-    public void dropOldChunks()
-    {
+    public void dropOldChunks() {
         // TODO chunkProvider#tick should be renamed, current name is extremely misleading as its called "tick" whilst not even being remotely connected to the actual tick system
-        while(chunkProvider.tick());
+        while (this.chunkProvider.tick()) ;
     }
 
-    public boolean canBlockIdBePlacedAt(final int id, final @NotNull TilePos tilePos, final boolean ignoreCollision, final @NotNull Side side) {
-        if (tilePos.y < 0 || tilePos.y >= this.getHeightBlocks()) {
+    public boolean canBlockIdBePlacedAt(final int id, final @NotNull TilePosc tilePos, final boolean ignoreCollision, final @NotNull Side side) {
+        if (tilePos.y() < 0 || tilePos.y() >= this.getHeightBlocks()) {
             return false;
         }
 
@@ -2535,11 +2304,11 @@ public class World implements MutableWorldSource {
             return false;
         }
 
-        final @Nullable AABB bb;
+        final @Nullable AABBdc bb;
         if (ignoreCollision) {
             bb = null;
         } else {
-            bb = newBlock.getCollisionBoundingBoxFromPool(this, tilePos.x, tilePos.y, tilePos.z);
+            bb = newBlock.getCollisionAABB(this, tilePos);
         }
 
         if (bb != null && !this.checkIfAABBIsClear(bb)) {
@@ -2547,7 +2316,7 @@ public class World implements MutableWorldSource {
         }
 
         if (currentBlock == null || currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) {
-            return newBlock.canPlaceBlockOnSide(this, tilePos.x, tilePos.y, tilePos.z, side);
+            return newBlock.canPlaceOnSide(this, tilePos, side);
         } else {
             return false;
         }
@@ -2558,12 +2327,11 @@ public class World implements MutableWorldSource {
         return this.canBlockIdBePlacedAt(id, new TilePos(x, y, z), ignoreCollision, side);
     }
 
-    public @Nullable Path getPathToEntity(Entity entity, Entity entityToTravelTo, float distance)
-    {
+    public @Nullable Path getPathToEntity(Entity entity, Entity entityToTravelTo, float distance) {
         int x1 = MathHelper.floor(entity.x);
         int y2 = MathHelper.floor(entity.y);
         int z1 = MathHelper.floor(entity.z);
-        int radius = (int)(distance + 16F);
+        int radius = (int) (distance + 16F);
         int xMin = x1 - radius;
         int yMin = y2 - radius;
         int zMin = z1 - radius;
@@ -2577,8 +2345,8 @@ public class World implements MutableWorldSource {
     public @Nullable Path getEntityPathToTilePos(final @NotNull Entity entity, final @NotNull TilePos tilePos, final float distance) {
         final @NotNull TilePos entityPos = new TilePos(entity);
         final int cacheRadius = (int) (distance + 8F);
-        final @NotNull TilePos cacheMin = entityPos.sub(cacheRadius, cacheRadius, cacheRadius);
-        final @NotNull TilePos cacheMax = entityPos.add(cacheRadius, cacheRadius, cacheRadius);
+        final @NotNull TilePos cacheMin = entityPos.sub(cacheRadius, cacheRadius, cacheRadius, new TilePos());
+        final @NotNull TilePos cacheMax = entityPos.add(cacheRadius, cacheRadius, cacheRadius, new TilePos());
 
         final @NotNull ChunkCache cache = new ChunkCache(this, cacheMin, cacheMax, false);
         if (!cache.allLoaded()) return null;
@@ -2590,9 +2358,9 @@ public class World implements MutableWorldSource {
         return this.getEntityPathToTilePos(entity, new TilePos(x, y, z), distance);
     }
 
-    public boolean hasDirectSignal(final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean hasDirectSignal(final @NotNull TilePosc tilePos, final @NotNull Side side) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
-        return block != null && block.getDirectSignal(this, tilePos.x, tilePos.y, tilePos.z, side);
+        return block != null && block.isEmittingDirectSignal(this, tilePos, side);
     }
 
     @Deprecated
@@ -2600,9 +2368,10 @@ public class World implements MutableWorldSource {
         return this.hasDirectSignal(new TilePos(x, y, z), side);
     }
 
-    public boolean hasDirectSignal(final @NotNull TilePos tilePos) {
+    public boolean hasDirectSignal(final @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
         for (final @NotNull Side side : Side.sides) {
-            if (this.hasDirectSignal(tilePos.add(side.getDirection()), side)) {
+            if (this.hasDirectSignal(tilePos.add(side.getDirection(), queryPos), side)) {
                 return true;
             }
         }
@@ -2615,7 +2384,7 @@ public class World implements MutableWorldSource {
         return this.hasDirectSignal(new TilePos(x, y, z));
     }
 
-    public boolean hasSignal(final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean hasSignal(final @NotNull TilePosc tilePos, final @NotNull Side side) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
         if (this.isBlockNormalCube(tilePos) && block != Blocks.BLOCK_REDSTONE && block != Blocks.PUMPKIN_REDSTONE && block != Blocks.MATCHER_ACTIVE) {
             return this.hasDirectSignal(tilePos);
@@ -2625,9 +2394,9 @@ public class World implements MutableWorldSource {
         }
 
         if (block == Blocks.PUMPKIN_REDSTONE) {
-            return this.pumpkinHasDirectSignal(tilePos) || block.getSignal(this, tilePos.x, tilePos.y, tilePos.z, side);
+            return this.pumpkinHasDirectSignal(tilePos) || block.isEmittingSignal(this, tilePos, side);
         } else {
-            return block.getSignal(this, tilePos.x, tilePos.y, tilePos.z, side);
+            return block.isEmittingSignal(this, tilePos, side);
         }
     }
 
@@ -2637,12 +2406,12 @@ public class World implements MutableWorldSource {
     }
 
     // Special version of hasDirectSignal that excludes the front side of the redstone lantern.
-    private boolean pumpkinHasDirectSignal(final @NotNull TilePos tilePos) {
+    private boolean pumpkinHasDirectSignal(final @NotNull TilePosc tilePos) {
         for (final @NotNull Side side : Side.sides) {
             if (Side.getSideById(this.getBlockData(tilePos)) == side) {
                 continue;
             }
-            if (this.hasDirectSignal(tilePos.add(side.getDirection()), side)) {
+            if (this.hasDirectSignal(tilePos.add(side.getDirection(), new TilePos()), side)) {
                 return true;
             }
         }
@@ -2650,9 +2419,9 @@ public class World implements MutableWorldSource {
         return false;
     }
 
-    public boolean hasNeighborSignal(final @NotNull TilePos tilePos) {
+    public boolean hasNeighborSignal(final @NotNull TilePosc tilePos) {
         for (final @NotNull Side side : Side.sides) {
-            if (this.hasSignal(tilePos.add(side.getDirection()), side)) {
+            if (this.hasSignal(tilePos.add(side.getDirection(), new TilePos()), side)) {
                 return true;
             }
         }
@@ -2665,21 +2434,19 @@ public class World implements MutableWorldSource {
         return this.hasNeighborSignal(new TilePos(x, y, z));
     }
 
-    public Player getClosestPlayerToEntity(Entity entity, double radius)
-    {
+    public Player getClosestPlayerToEntity(Entity entity, double radius) {
         return getClosestPlayer(entity.x, entity.y, entity.z, radius);
     }
 
     /**
      * @param radius Radius around the point to search for a player, a radius less than 0 denotes searching for the closest player with 0 regard for radius
      */
-    public Player getClosestPlayer(double x, double y, double z, double radius)
-    {
+    public Player getClosestPlayer(double x, double y, double z, double radius) {
         double closestDistance = Double.POSITIVE_INFINITY;
         Player entityplayer = null;
         if (radius < 0) {
 
-            for (Player entityPlayer1 : players) {
+            for (Player entityPlayer1 : this.players) {
                 double currentDistance = entityPlayer1.distanceToSqr(x, y, z);
                 if ((currentDistance < closestDistance)) {
                     closestDistance = currentDistance;
@@ -2688,7 +2455,7 @@ public class World implements MutableWorldSource {
             }
         } else {
             double rSquared = radius * radius;
-            for (Player entityPlayer1 : players) {
+            for (Player entityPlayer1 : this.players) {
                 double currentDistance = entityPlayer1.distanceToSqr(x, y, z);
                 if (currentDistance < rSquared && (currentDistance < closestDistance)) {
                     closestDistance = currentDistance;
@@ -2700,10 +2467,8 @@ public class World implements MutableWorldSource {
     }
 
 
-
-    public Player getPlayerEntityByName(String s)
-    {
-        for (Player player : players) {
+    public Player getPlayerEntityByName(String s) {
+        for (Player player : this.players) {
             if (s.equals(player.username)) {
                 return player;
             }
@@ -2712,8 +2477,7 @@ public class World implements MutableWorldSource {
         return null;
     }
 
-    public Player getPlayerEntityByUUID(@Nullable final UUID uuid)
-    {
+    public Player getPlayerEntityByUUID(@Nullable final UUID uuid) {
         for (final Player player : this.players) {
             if (player.uuid.equals(uuid)) {
                 return player;
@@ -2723,8 +2487,7 @@ public class World implements MutableWorldSource {
         return null;
     }
 
-    public void setChunkData(int x, int y, int z, int width, int height, int length, byte[] data)
-    {
+    public void setChunkData(int x, int y, int z, int width, int height, int length, byte[] data) {
         int minChunkX = Math.floorDiv(x, Chunk.CHUNK_SIZE_X);
         int minChunkZ = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z);
         int maxChunkX = Math.floorDiv((x + width) - 1, Chunk.CHUNK_SIZE_X);
@@ -2732,36 +2495,28 @@ public class World implements MutableWorldSource {
         int startIndex = 0;
         int minY = y;
         int maxY = y + height;
-        if(minY < 0)
-        {
+        if (minY < 0) {
             minY = 0;
         }
-        if(maxY > getHeightBlocks())
-        {
+        if (maxY > getHeightBlocks()) {
             maxY = getHeightBlocks();
         }
-        for(int chunkX = minChunkX; chunkX <= maxChunkX; chunkX++)
-        {
+        for (int chunkX = minChunkX; chunkX <= maxChunkX; chunkX++) {
             int minX = x - chunkX * Chunk.CHUNK_SIZE_X;
             int maxX = (x + width) - chunkX * Chunk.CHUNK_SIZE_X;
-            if(minX < 0)
-            {
+            if (minX < 0) {
                 minX = 0;
             }
-            if(maxX > Chunk.CHUNK_SIZE_X)
-            {
+            if (maxX > Chunk.CHUNK_SIZE_X) {
                 maxX = Chunk.CHUNK_SIZE_X;
             }
-            for(int chunkZ = minChunkZ; chunkZ <= maxChunkZ; chunkZ++)
-            {
+            for (int chunkZ = minChunkZ; chunkZ <= maxChunkZ; chunkZ++) {
                 int minZ = z - chunkZ * Chunk.CHUNK_SIZE_Z;
                 int maxZ = (z + length) - chunkZ * Chunk.CHUNK_SIZE_Z;
-                if(minZ < 0)
-                {
+                if (minZ < 0) {
                     minZ = 0;
                 }
-                if(maxZ > Chunk.CHUNK_SIZE_Z)
-                {
+                if (maxZ > Chunk.CHUNK_SIZE_Z) {
                     maxZ = Chunk.CHUNK_SIZE_Z;
                 }
                 startIndex = getChunkFromChunkCoords(chunkX, chunkZ).setChunkData(data, minX, minY, minZ, maxX, maxY, maxZ, startIndex);
